'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _rxjs = require('rxjs');

var _rxjs2 = _interopRequireDefault(_rxjs);

var _isObservable = require('is-observable');

var _isObservable2 = _interopRequireDefault(_isObservable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

/**
 * combine multiple reducers (observable streams of functions)
 * into one stream that is pushed to `createState`.
 *
 * It is the stream of functions that take one argument (state)
 * and generate newState with this function.
 *
 * @param  {Observable|Array} reducers one reducer or array of reducers
 * streams (Observables).
 * @return {Observable} Observable that produces functions how to
 * modify state.
 */
var combineReducers = function combineReducers() {
  var _Rx$Observable;

  for (var _len = arguments.length, reducers = Array(_len), _key = 0; _key < _len; _key++) {
    reducers[_key] = arguments[_key];
  }

  var reducersArr = [].concat(reducers).filter(function (item) {
    return (0, _isObservable2['default'])(item);
  });
  // console.log('RA: ', reducersArr);
  return (_Rx$Observable = _rxjs2['default'].Observable).merge.apply(_Rx$Observable, (0, _toConsumableArray3['default'])(reducersArr));
};

// IDEA some flattening so the structure may go into this function and this structure can maintain even the state structure like Redux (branching the state).

exports['default'] = combineReducers;